<template>
    <table id="datatable-buttons" class="table table-striped table-bordered">
        <thead>
            <tr>
                <th>#</th>
                <th>Codigo</th>
                <th># Descuento</th>
                <th>% de Descuento</th>
                <th>Estado</th>
                <th>Fecha de exp.</th>
                <th>Acciones</th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="(item, i) in promo" :key="item.id">
                <td>{{ i++ }}</td>
                <td>{{ item.promo_code }}</td>
                <td>{{ item.value_desc ? item.value_desc + "USD" : "" }}</td>
                <td>{{ item.percent_desc ? item.percent_desc + "%" : "" }}</td>
                <td>{{ item.status ? "Activo" : "Inactivo" }}</td>
                <td>{{ item.expiration_date }}</td>
                <td></td>
            </tr>
        </tbody>
        <!-- crear usuario -->
        <div
            class="modal fade"
            id="crearModal"
            tabindex="-1"
            role="dialog"
            aria-labelledby="crearModalLabel"
            aria-hidden="true"
        >
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="crearModalLabel">
                            Agregar nuevo codigo promocional
                        </h5>
                        <button
                            type="button"
                            class="close"
                            data-dismiss="modal"
                            aria-label="Close"
                        >
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form method="POST">
                            <!-- Alerta de error -->
                            <div
                                v-if="error"
                                id="errorAlert"
                                class="alert alert-danger alert-dismissible fade show"
                                role="alert"
                            >
                                <strong>Ohh no!</strong> {{ error }}.
                                <button
                                    type="button"
                                    class="close"
                                    v-on:click.prevent="closeAlert()"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <!-- fin de error -->
                            <div class="form-group">
                                <input
                                    type="text"
                                    placeholder="Codigo promocional único"
                                    class="form-control "
                                    name="promo_code"
                                    v-model="newPromo.promo_code"
                                    required
                                    autocomplete="promo_code"
                                    autofocus
                                />
                            </div>
                            <div class="form-group">
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <div class="row">
                                                <div class="col-7">
                                                    <p>
                                                        Codigo por Porcentaje de
                                                        desc.
                                                    </p>
                                                </div>
                                                <div class="col-5">
                                                    <input
                                                        type="checkbox"
                                                        class="js-switch"
                                                        name="perc"
                                                        value="true"
                                                        v-model="perc"
                                                    />
                                                </div>
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <div class="row">
                                                <div class="col-7">
                                                    <p>
                                                        Codigo por valor de
                                                        desc.
                                                    </p>
                                                </div>
                                                <div class="col-5">
                                                    <input
                                                        type="checkbox"
                                                        class="js-switch"
                                                        name="val"
                                                        value="true"
                                                        v-model="val"
                                                    />
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-md-6 align-middle">
                                        <div class="form-group">
                                            <div class="input-group">
                                                <input
                                                    type="text"
                                                    placeholder="Porcentaje de descuento"
                                                    class="form-control"
                                                    name="percent_desc"
                                                    v-model="
                                                        newPromo.percent_desc
                                                    "
                                                    :disabled="!perc || val"
                                                    required
                                                    autocomplete="percent_desc"
                                                />
                                                <div class="input-group-append">
                                                    <span
                                                        class="input-group-text"
                                                        id="basic-addon2"
                                                        >%</span
                                                    >
                                                </div>
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <div class="input-group">
                                                <input
                                                    type="string"
                                                    placeholder="Monto de descuento especifico"
                                                    class="form-control"
                                                    name="value_desc"
                                                    v-model="
                                                        newPromo.value_desc
                                                    "
                                                    :disabled="!val || perc"
                                                    required
                                                    autocomplete="value_desc"
                                                />
                                                <div class="input-group-append">
                                                    <span
                                                        class="input-group-text"
                                                        id="basic-addon2"
                                                        >USD</span
                                                    >
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="form-group">
                                <div class="row">
                                    <div class="col-1"></div>
                                    <div class="col-4">
                                        <p>Fecha de expiración</p>
                                    </div>
                                    <div class="col-7">
                                        <input
                                            type="date"
                                            id="expiration_date"
                                            placeholder="Fecha de expiración"
                                            class="form-control"
                                            name="expiration_date"
                                            v-model="newPromo.expiration_date"
                                            required
                                            autocomplete="expiration_date"
                                            :min="today()"
                                        />
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button
                            type="button"
                            class="btn btn-secondary"
                            data-dismiss="modal"
                        >
                            Close
                        </button>
                        <button
                            v-on:click.prevent="createPromo()"
                            type="button"
                            class="btn btn-primary"
                            id="submit"
                        >
                            Crear
                        </button>
                    </div>
                </div>
            </div>
        </div>
        <!-- fin crear usuario -->
    </table>
</template>

<script>
export default {
    props: ["code"],
    created: function() {},
    mounted() {
        this.init();
    },
    data() {
        return {
            promo: this.code,
            newPromo: {
                promo_code: "",
                percent_desc: "",
                value_desc: "",
                expiration_date: this.today(),
                status: true
            },
            error: "",
            url: "/api/config/promo-code",
            perc: false,
            val: false
        };
    },
    methods: {
        today() {
            var today = new Date();

            var año = today.getFullYear();

            if (today.getMonth() + 1 < 10) {
                var mes = "0" + (today.getMonth() + 1);
            } else {
                var mer = today.getMonth() + 1;
            }
            if (today.getDate() < 10) {
                var dia = "0" + today.getDate();
            } else {
                var dia = today.getDate();
            }

            var date = año + "-" + mes + "-" + dia;
            return date;
        },
        init() {
            var primary_small = document.querySelectorAll(".js-switch");
            primary_small.forEach(e => {
                var switchery = new Switchery(e, {
                    color: "#6e81dc",
                    size: "small"
                });
            });
        },
        get: function() {
            axios.get(this.url).then(res => {
                this.promo = res.data;
                console.log(this.promo);
            });
        },
        createPromo() {
            $("#submit").attr("disabled", true);
            let banco = this.newPromo;
            if (this.newPromo.promo_code) {
                if (this.perc && this.val) {
                    this.error = "Debe agregar solo un tipo de descuento.";
                    return false;
                } else if (!this.perc && !this.val) {
                    this.error =
                        "Debe agregar un tipo de descuento al codigo promocional ";
                    return false;
                }
                if (this.perc) {
                    if (this.newPromo.percent_desc) {
                        this.newPromo.value_desc = "";
                        axios.post(this.url, this.newPromo).then(res => {
                            console.log(res.data);
                            if (res.data.error) {
                                this.error = res.data.error;
                            } else {
                                this.get();
                                $("#submit").attr("disabled", false);
                                $("#crearModal").modal("toggle");
                                $(".modal-backdrop").remove();
                                $("#crearModal").attr("disabled", false);
                            }
                        });
                    } else {
                        this.error =
                            "Debe asignar un porcentaje de descuento al codigo promocional";
                    }
                } else if (this.val) {
                    if (this.newPromo.value_desc) {
                        this.newPromo.percent_desc = "";
                        axios.post(this.url, this.newPromo).then(res => {
                            console.log(res.data);
                            if (res.data.error) {
                                this.error = res.data.error;
                            } else {
                                this.get();
                                $("#submit").attr("disabled", false);
                                $("#crearModal").modal("toggle");
                                $(".modal-backdrop").remove();
                                $("#crearModal").attr("disabled", false);
                            }
                        });
                    } else {
                        this.error =
                            "Debe asignar un valor de descuento fijo al codigo promocional.";
                    }
                } else {
                    this.error = "Debe asignar un tipo de descuento";
                }
            } else {
                this.error =
                    "Debe agregar un nombre único al codigo promocional";
            }
        },
        updateBanco(item) {
            $("#edit" + item.id).attr("disabled", true);

            if (
                item.name_banco &&
                item.tipo_cuenta &&
                item.numero_cuenta &&
                item.nombre_persona &&
                item.documento &&
                item.documento_type &&
                item.email
            ) {
                if (
                    Number.isInteger(Number(item.documento)) &&
                    Number.isInteger(Number(item.numero_cuenta))
                ) {
                    axios.put(this.url + "/" + item.id, item).then(res => {
                        this.get();
                        $("#edodal" + item.id).modal("toggle");
                        $(".modal-bacitMkdrop").remove();
                        $("#edit" + item.id).attr("disabled", false);
                    });
                } else {
                    this.error =
                        "Recuerde que los números de cuenta y documento deben ser solo númericos, debe evitar usar carácteres especiales y/0 letras en estos campos";
                    $("#edit" + item.id).attr("disabled", false);
                }
            } else {
                this.error =
                    "Para continuar debe completar todos los campos requeridos";
                $("#edit" + item.id).attr("disabled", false);
            }
        },
        deleteBank(i) {
            axios.delete(this.url + "/" + i).then(res => {
                this.get();
                $("#deleteModal" + i.id).modal("toggle");
                $(".modal-backdrop").remove();
            });
        },
        closeAlert() {
            this.error = "";
            $("#submit").attr("disabled", false);
        }
    }
};
</script>
